package com.gingersoft.supply_chain.mvp.model;

import android.app.Application;

import com.gingersoft.gsa.cloud.common.bean.BaseResult;
import com.gingersoft.supply_chain.mvp.contract.NewSupplierContract;
import com.gingersoft.supply_chain.mvp.server.SupplierServer;
import com.google.gson.Gson;
import com.jess.arms.di.scope.FragmentScope;
import com.jess.arms.integration.IRepositoryManager;
import com.jess.arms.mvp.BaseModel;

import java.util.Map;

import javax.inject.Inject;

import io.reactivex.Observable;
import okhttp3.RequestBody;


/**
 * ================================================
 * Description:
 * <p>
 * Created by MVPArmsTemplate on 11/19/2020 18:33
 * <a href="mailto:jess.yan.effort@gmail.com">Contact me</a>
 * <a href="https://github.com/JessYanCoding">Follow me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms">Star me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms/wiki">See me</a>
 * <a href="https://github.com/JessYanCoding/MVPArmsTemplate">模版请保持更新</a>
 * ================================================
 */
@FragmentScope
public class NewSupplierModel extends BaseModel implements NewSupplierContract.Model {
    @Inject
    Gson mGson;
    @Inject
    Application mApplication;

    @Inject
    public NewSupplierModel(IRepositoryManager repositoryManager) {
        super(repositoryManager);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        this.mGson = null;
        this.mApplication = null;
    }

    @Override
    public Observable<BaseResult> addSupplier(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).addSupplier(requestBody);
    }

    @Override
    public Observable<BaseResult> updateSupplier(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).updateSupplier(requestBody);
    }

    @Override
    public Observable<BaseResult> getSupplierContact(String supplierId) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).getSupplierContact(supplierId);
    }

    @Override
    public Observable<BaseResult> updateSupplierContact(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).updateSupplierContact(requestBody);
    }

    @Override
    public Observable<BaseResult> addSupplierContact(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).addSupplierContact(requestBody);
    }

    @Override
    public Observable<BaseResult> deleteSupplier(int supplierId) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).deleteSupplier(supplierId);
    }

    @Override
    public Observable<BaseResult> getSupplierInfo(Map<String, Object> map) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).getSupplierInfo(map);
    }
}